--- bootstrap.output.bjarni	2021-08-17 15:19:25.000000000 +0000
+++ /tmp/bootstrap.brandon	2021-08-17 19:05:18.000000000 +0000
@@ -1,6 +1,7 @@
-Is on branch bjarni
-./bootstrap: Bootstrapping from checked-out groff sources...
-./bootstrap: /home/bg/git/gnulib/gnulib-tool    --no-changelog   --aux-dir=build-aux   --doc-base=doc   --lib=libgnu   --m4-base=gnulib_m4/   --source-base=lib/   --tests-base=tests   --local-dir=gl   --makefile-name=gnulib.mk   --import ...
+./bootstrap: Bootstrapping from checked-out troff sources...
+./bootstrap: consider installing git-merge-changelog from gnulib
+./bootstrap: getting gnulib files...
+./bootstrap: gnulib/gnulib-tool  --import --no-changelog --aux-dir build-aux --doc-base doc --lib libgnu --m4-base gnulib_m4/ --source-base lib/ --tests-base tests --local-dir gl --makefile-name=gnulib.mk --import ...
 Module list with included dependencies (indented):
     absolute-header
     alloca-opt
@@ -13,7 +14,6 @@ Module list with included dependencies (
     fpieee
   fprintf-posix
     fpucw
-    free-posix
     frexp-nolibm
     frexpl-nolibm
     fseterr
@@ -36,7 +36,6 @@ Module list with included dependencies (
     printf-safe
     signbit
     size_max
-    snippet/_Noreturn
     snippet/arg-nonnull
     snippet/c++defs
     snippet/warn-on-use
@@ -46,11 +45,9 @@ Module list with included dependencies (
     stddef
     stdint
     stdio
-    stdlib
     streq
     string
     sys_types
-    unistd
     unitypes
     uniwidth/base
     uniwidth/width
@@ -65,7 +62,6 @@ File list:
   build-aux/config.rpath
   build-aux/git-version-gen
   build-aux/prefix-gnulib-mk
-  lib/_Noreturn.h
   lib/alloca.in.h
   lib/arg-nonnull.h
   lib/asnprintf.c
@@ -77,7 +73,6 @@ File list:
   lib/float.in.h
   lib/fprintf.c
   lib/fpucw.h
-  lib/free.c
   lib/frexp.c
   lib/frexpl.c
   lib/fseterr.c
@@ -115,12 +110,9 @@ File list:
   lib/stdint.in.h
   lib/stdio-impl.h
   lib/stdio.in.h
-  lib/stdlib.in.h
   lib/streq.h
   lib/string.in.h
   lib/sys_types.in.h
-  lib/unistd.c
-  lib/unistd.in.h
   lib/unitypes.in.h
   lib/uniwidth.in.h
   lib/uniwidth/cjk.h
@@ -149,7 +141,6 @@ File list:
   m4/float_h.m4
   m4/fpieee.m4
   m4/fprintf-posix.m4
-  m4/free.m4
   m4/frexp.m4
   m4/frexpl.m4
   m4/fseterr.m4
@@ -189,10 +180,8 @@ File list:
   m4/stdint.m4
   m4/stdint_h.m4
   m4/stdio_h.m4
-  m4/stdlib_h.m4
   m4/string_h.m4
   m4/sys_types_h.m4
-  m4/unistd_h.m4
   m4/vasnprintf.m4
   m4/vsnprintf.m4
   m4/warn-on-use.m4
@@ -210,54 +199,17 @@ You may need to add #include directives
   #include <stdio.h>
   #include <wchar.h>
 
-You may need to use the following Makefile variables when linking.
-Use them in <program>_LDADD when linking a program, or
-in <library>_a_LDFLAGS or <library>_la_LDFLAGS when linking a library.
-  $(LTLIBUNISTRING) when linking with libtool, $(LIBUNISTRING) otherwise
-
 Don't forget to
   - "include gnulib.mk" from within "lib/Makefile.am",
   - mention "-I gnulib_m4" in ACLOCAL_AMFLAGS in Makefile.am,
   - mention "gnulib_m4/gnulib-cache.m4" in EXTRA_DIST in Makefile.am,
   - invoke gl_EARLY in ./configure.ac, right after AC_PROG_CC,
   - invoke gl_INIT in ./configure.ac.
-prefix=lib/
 running: AUTOPOINT=true LIBTOOLIZE=true autoreconf --verbose --install --force -I gnulib_m4  --no-recursive
-autoreconf: export WARNINGS=
-autoreconf: Entering directory '.'
-autoreconf: configure.ac: not using Gettext
-autoreconf: running: aclocal -I gnulib_m4 --force -I m4 -I gnulib_m4
-autoreconf: configure.ac: tracing
-autoreconf: configure.ac: not using Libtool
-autoreconf: configure.ac: not using Intltool
-autoreconf: configure.ac: not using Gtkdoc
-autoreconf: running: /usr/local/bin/autoconf --include=gnulib_m4 --force
-configure.ac:21: warning: AC_INIT: not a literal: "m4_esyscmd(build-aux/git-version-gen --prefix "" .tarball-version)"
-configure.ac:158: warning: The macro `AC_FOREACH' is obsolete.
-configure.ac:158: You should run autoupdate.
-../lib/autoconf/general.m4:191: AC_FOREACH is expanded from...
-m4/groff.m4:224: GROFF_HTML_PROGRAMS is expanded from...
-configure.ac:158: the top level
-autoreconf: running: /usr/local/bin/autoheader --include=gnulib_m4 --force
-autoreconf: running: automake --add-missing --copy --force-missing
-lib/gnulib.mk:52: warning: variable 'EXTRA_lib_libgnu_a_SOURCES' is defined but no program or
-lib/gnulib.mk:52: library has 'lib_libgnu_a' as canonical name (possible typo)
-Makefile.am:647:   'lib/gnulib.mk' included from here
-lib/gnulib.mk:49: warning: variable 'lib_libgnu_a_SOURCES' is defined but no program or
-lib/gnulib.mk:49: library has 'lib_libgnu_a' as canonical name (possible typo)
-Makefile.am:647:   'lib/gnulib.mk' included from here
-lib/gnulib.mk:50: warning: variable 'lib_libgnu_a_LIBADD' is defined but no program or
-lib/gnulib.mk:50: library has 'lib_libgnu_a' as canonical name (possible typo)
-Makefile.am:647:   'lib/gnulib.mk' included from here
-lib/gnulib.mk:51: warning: variable 'lib_libgnu_a_DEPENDENCIES' is defined but no program or
-lib/gnulib.mk:51: library has 'lib_libgnu_a' as canonical name (possible typo)
-Makefile.am:647:   'lib/gnulib.mk' included from here
-autoreconf: 'build-aux/config.sub' is updated
-autoreconf: 'build-aux/config.guess' is updated
-autoreconf: Leaving directory '.'
-./bootstrap: ln -fs /home/bg/git/gnulib/build-aux/install-sh build-aux/install-sh
-./bootstrap: ln -fs /home/bg/git/gnulib/build-aux/depcomp build-aux/depcomp
-./bootstrap: ln -fs /home/bg/git/gnulib/build-aux/config.guess build-aux/config.guess
-./bootstrap: ln -fs /home/bg/git/gnulib/build-aux/config.sub build-aux/config.sub
-./bootstrap: ln -fs /home/bg/git/gnulib/doc/INSTALL INSTALL
+./bootstrap: ln -fs ../gnulib/build-aux/install-sh build-aux/install-sh
+./bootstrap: ln -fs ../gnulib/build-aux/depcomp build-aux/depcomp
+./bootstrap: ln -fs ../gnulib/build-aux/config.guess build-aux/config.guess
+./bootstrap: ln -fs ../gnulib/build-aux/config.sub build-aux/config.sub
+./bootstrap: ln -fs gnulib/doc/INSTALL INSTALL
 ./bootstrap: done.  Now you can run './configure'.
+